<template>
  <teleport to="body">
    <dialog open v-if="show">
      <div class="dialog-content">
        <header class="flex">
          <slot name="header">
            <h2>{{ title }}</h2>
          </slot>
          <div class="btn-close" @click="tryClose">
            <img src="@/assets/icon-close.svg" />
          </div>
        </header>
        <section>
          <slot></slot>
        </section>
      </div>
    </dialog>
  </teleport>
</template>

<script>
export default {
  props: {
    show: {
      type: Boolean,
      required: true,
    },
    title: {
      type: String,
      required: false,
    },
    fixed: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  emits: ["close"],
  methods: {
    tryClose() {
      if (this.fixed) {
        return;
      }
      this.$emit("close");
    },
  },
};
</script>

<style scoped>
dialog {
  position: fixed;
  top: 0px;
  left: 0px;
  display: flex;
  align-items: center;
  justify-content: center;
  width: 100%;
  height: 100vh;
  z-index: 100;
  background-color: rgba(0, 0, 0, 0.5);
}

.dialog-content {
  width: 100%;
  max-width: 24rem;
  margin-bottom: 1.5rem;
  border-radius: 0.5rem;
  padding: 1rem;
  background: var(--neutral-white);
}
header {
  width: 100%;
  color: var(--neutral-dark);
  text-transform: uppercase;
  justify-content: space-between;
}

header h2 {
  margin: 0;
}
.btn-close {
  cursor: pointer;
}
</style>
